//****************************************************************************
//	aisa41w.pas
//
//	aISA-P41
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/06/25
//
//****************************************************************************

unit aisa41w;

interface

uses
	Windows;

{ Errors }

const
	AISA41_SUCCESS							= 0;	 { ُȂ }
	AISA41_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA41_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA41_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA41_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA41_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA41_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA41_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Direction }

const
	AISA41_DIR_A_OUTPUT	= 0 shl 0;
	AISA41_DIR_A_INPUT	= 1 shl 0;
	AISA41_DIR_B_OUTPUT	= 0 shl 1;
	AISA41_DIR_B_INPUT	= 1 shl 1;
	AISA41_DIR_C_OUTPUT	= 0 shl 2;
	AISA41_DIR_C_INPUT	= 1 shl 2;
	AISA41_DIR_D_OUTPUT	= 0 shl 3;
	AISA41_DIR_D_INPUT	= 1 shl 3;
	AISA41_DIR_E_OUTPUT	= 0 shl 4;
	AISA41_DIR_E_INPUT	= 1 shl 4;
	AISA41_DIR_F_OUTPUT	= 0 shl 5;
	AISA41_DIR_F_INPUT	= 1 shl 5;
  AISA41_DIR_G_OUTPUT	= 0 shl 6;
	AISA41_DIR_G_INPUT	= 1 shl 6;
  AISA41_DIR_H_OUTPUT	= 0 shl 7;
	AISA41_DIR_H_INPUT	= 1 shl 7;

{ Port numbers }

const
	AISA41_PORT_A	= 0;
	AISA41_PORT_B	= 1;
  AISA41_PORT_C	= 2;
	AISA41_PORT_D	= 3;
  AISA41_PORT_E	= 4;
	AISA41_PORT_F	= 5;
  AISA41_PORT_G	= 6;
	AISA41_PORT_H	= 7;

{ Miscellaneous }

const
	AISA41_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA41_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA41_DLL_NAME = 'aisa41.dll';		{ DLL }

function Aisa41wDllOpen: Boolean;			{ DLL [h }
function Aisa41wDllClose: Boolean;		{ DLL A[h }


const
	AISA41_SLOT_AUTO = $ffff;

{ aISA-P41 DLL,Driver̃o[Wԍ擾 }
function Aisa41wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P41̎gp錾 }
function Aisa41wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P41̎gpJ }
function Aisa41wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA41_MAX_MEM	=	 9;
		AISA41_MAX_IO		= 20;
		AISA41_MAX_IRQ	=	 7;
		AISA41_MAX_DMA	=	 7;

type
		TAISA41RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA41_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA41_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA41_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA41_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA41_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA41_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA41_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA41_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA41_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA41RESOURCE = ^TAISA41RESOURCE;

{ \[X擾 }
function Aisa41wGetResource(wLogSlot: Word;  pResInfo: PAISA41RESOURCE): Boolean;

{ fBNVZbg }
function Aisa41wSetDirections(wLogSlot: Word; dwDirections: DWord): Boolean;

{ Cӂ̃|[gf[^ }
function Aisa41wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa41wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;


{ aISA-P41̃G[R[h }
function Aisa41wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa41GetVersion = function(var pdwDllVer: DWORD; var	pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa41Create = function(var pwLogSlot: WORD): BOOL; stdcall;
	TAisa41Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa41GetResource = function(wLogSlot: WORD; res: PAISA41RESOURCE):	BOOL; stdcall;
  TAisa41SetDirections = function(wLogSlot: WORD; dwDirections:	DWORD):	BOOL; stdcall;
	TAisa41InPort = function(wLogSlot: WORD; dwLogPort: DWORD; var lpbInValue: BYTE): BOOL; stdcall;
	TAisa41OutPort = function(wLogSlot: WORD; dwLogPort: DWORD; bOutValue: BYTE): BOOL; stdcall;
	TAisa41GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa41wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa41GetVersion: TAisa41GetVersion;
	pAisa41Create: TAisa41Create;
	pAisa41Close: TAisa41Close;
	pAisa41GetResource: TAisa41GetResource;
  pAisa41SetDirections: TAisa41SetDirections;
	pAisa41InPort: TAisa41InPort;
	pAisa41OutPort: TAisa41OutPort;
	pAisa41GetLastError: TAisa41GetLastError;


//****************************************************************************
// @\			aisa41.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa41wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA41_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa41wGetDllExportFunc = False then
  begin
       Aisa41wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa41.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa41wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-P41 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drivero[Wԍi[
// ߂l 	True  	  --- 
//		  		False 		--- s
//****************************************************************************
function Aisa41wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa41GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-P41̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa41wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa41Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-P41̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa41wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa41Close(wLogSlot);
end;

//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa41wGetResource(wLogSlot: Word;  pResInfo: PAISA41RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa41GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// 		fBNVZbg
// 		wLogSlot		 --- ZbgfoCX
//				dwDirections --- Zbge
// ߂l True         --- 
//				False        --- s
//****************************************************************************
function Aisa41wSetDirections(wLogSlot: Word; dwDirections: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa41SetDirections(wLogSlot, dwDirections);
end;

//****************************************************************************
// @\			Cӂ̃|[gf[^
// 			wLogSlot	--- ͂foCX
//					dwPort		--- ͂|[g
//					pbInValue --- ̓f[^i[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa41wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa41InPort(wLogSlot, dwPort, pbInValue);
end;

//****************************************************************************
// @\			Cӂ̃|[gփf[^o
// 			wLogSlot	--- o͂foCX
//					dwPort		--- o͂|[g
//					bOutValue --- o͂f[^
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa41wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa41OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// @\			aISA-P41̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa41wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA41_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa41GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa41wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa41GetVersion ̃AhX擾
	pAisa41GetVersion := GetProcAddress(hDLL, 'Aisa41GetVersion');
	if @pAisa41GetVersion = nil then Exit;

	// Aisa41Create ̃AhX擾
	pAisa41Create := GetProcAddress(hDLL, 'Aisa41Create');
	if @pAisa41Create = nil then Exit;

	// Aisa41Close ̃AhX擾
	pAisa41Close := GetProcAddress(hDLL, 'Aisa41Close');
	if @pAisa41Close = nil then Exit;

	// Aisa41GetResource ̃AhX擾
	pAisa41GetResource := GetProcAddress(hDLL, 'Aisa41GetResource');
	if @pAisa41GetResource = nil then Exit;

  // Aisa41SetDirections ̃AhX擾
	pAisa41SetDirections := GetProcAddress(hDLL, 'Aisa41SetDirections');
	if @pAisa41SetDirections = nil then Exit;

	// Aisa41InPort ̃AhX擾
	pAisa41InPort := GetProcAddress(hDLL, 'Aisa41InPort');
	if @pAisa41InPort = nil then Exit;

	// Aisa41OutPort ̃AhX擾
	pAisa41OutPort := GetProcAddress(hDLL, 'Aisa41OutPort');
	if @pAisa41OutPort = nil then Exit;

	// Aisa41GetLastError ̃AhX擾
	pAisa41GetLastError := GetProcAddress(hDLL, 'Aisa41GetLastError');
	if @pAisa41GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

