/*****************************************************************************
 *	aisa41s.c
 *
 *	aISA-P41
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *****************************************************************************/
#define	STRICT
#include	<windows.h>
#include	<tchar.h>
#include	"aisa41w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP41[] = _T("aISA-P41");
static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
												LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	BYTE  InValue, OutValue;
	AISA41RESOURCE ri;				// \[X
	DWORD dwDirections;				// fBNV

//-----------------	 aisa41.dll ̎gp錾 --------------------------------
	if (Aisa41wDllOpen() == FALSE) {
		ErrorMessage(AISA41_SLOT_AUTO);
		return 1;			// aisa41.dll ̃[hɎs܂
	}

//--------------------	o[Wԍ\	----------------------------------
	// aISA-P41 DLL,Driver̃o[Wԍ擾
	if (Aisa41wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE) {
		ErrorMessage(AISA41_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("GetVersion\n") _T("DLL Version: %08lxh\n")
							_T("Drv Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);

//-----------------------  aISA-P41̎gp錾	 ---------------------------

	dwDirections = 0xFF;					// ׂē͂Ƃď
	wLogSlot = AISA41_SLOT_AUTO;			// gp̃foCXT܂B
	bResult = Aisa41wCreate( &wLogSlot );
				// wLogSlot -- ꍇA̎̃foCXi[܂B
	if (bResult == FALSE) {
		ErrorMessage(AISA41_SLOT_AUTO);		// foCX܂B
		return 1;
	}
	wsprintf(szbuf, _T("aISA-P41 Created\n\n") _T("LogSlot: %2d\n"), wLogSlot);
	ResultMessage(szbuf);

//------------------------------  \[X擾  -------------------------
	if (Aisa41wGetResource(wLogSlot, &ri) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("Board Name: %s\n") _T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n") ,
					szP41, ri.dwIOPortLength[0], ri.dwIOPortBase[0],
					ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1 );
	ResultMessage(szbuf);

//---------------	PortA ̃fBNVo͂ɐݒ	-----------------------

	// PortA ̃rbgo͂ɕύX܂B
	dwDirections = dwDirections & ~AISA41_DIR_A_INPUT;	//portAo(0)

	// fBNVZbg
	if (Aisa41wSetDirections(wLogSlot, dwDirections) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("PortÃfBNVo͂ɕύX"));

//------------------   PortA ɔCӂ̃f[^o  ----------------------------
	OutValue = (BYTE)0xAA;					// o̓f[^ AAh

	if (Aisa41wOutPort(wLogSlot, AISA41_PORT_A, OutValue) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("A Portփf[^o\n")
					_T("A Port Out Data: %02xh"), OutValue);
	ResultMessage(szbuf);

//---------------	PortA ̃fBNV͂ɐݒ	-----------------------

	// PortA ̃rbgo͂ɕύX܂B
	dwDirections = dwDirections | AISA41_DIR_A_INPUT;	//portA(1)

	// fBNVZbg
	if (Aisa41wSetDirections(wLogSlot, dwDirections) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("PortÃfBNV͂ɕύX"));

//---------------------	 PortA f[^ǂݍ	 -------------------------
	InValue = (BYTE)0x00;

	if (Aisa41wInPort(wLogSlot, AISA41_PORT_A, &InValue) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("A Portf[^\n")
					_T("A Port In Data: %02xh"), InValue);
	ResultMessage(szbuf);

//-------------------  aISA-P41̎gpJ	 -------------------------------
	if (Aisa41wClose(wLogSlot) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aISA-P41 Closed"));

//----------------------  aisa41.dll ̎gpJ  ----------------------------
	if (Aisa41wDllClose() == FALSE) {
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"),
										szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa41.dll ̃A[hɎs܂B
	}
	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa41wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes) {
		case AISA41_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"), GetLastError());
			break;

		case AISA41_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-P41 error\n\n")
							_T("Error code: %08lxh"), dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
